      SUBROUTINE EXT_TOVS(KNBMESS,KNBMECR,CDTYPM,KNBWAG,
     &                     PLATN,PLATS,PLONO,PLONE,KPLEIN)
!-----------------------------------------------------------------------
! 01/01/1999 : mise en place boucle eclatement LMOD1C
!-----------------------------------------------------------------------
!  auteur de revision : F. Guillaume
!  date de revision   : 17/03/2008
!  objet              : formats explicites d'ecriture dans OBSOUL
!                       pour mise en conofmite SOPRANO.
!=======================================================================

      IMPLICIT LOGICAL(L)

#include "oulan_pardimo.h"
#include "oulan_yomtomv.h"
#include "oulan_yompin.h"
#include "oulan_yomdirs.h"
#include "oulan_yomnbob.h"
#include "oulan_yomdate.h"
#include "oulan_yomcsts.h"

      PARAMETER ( JP_NBX_PAR = 50  )

      CHARACTER  CLLAT            *  12 , CLLON                   *   12
      CHARACTER  CDTYPM           *  10 , CL_NULL                 *    5

      CHARACTER  CL_TYPE_MESS     * 20 , CL_VERS_MESS              * 20
      CHARACTER  CL_MIN_DATE      * 14 , CL_MAX_DATE               * 14
      CHARACTER  CL_LAST_ARRIVED  *  1 , CL_LISTE_PARAM(1)         * 15
      CHARACTER  CL_LISTE_STAT(1) *  4 , CL_DONNEES(5,KNBMESS)     * 80
      CHARACTER  CL_AUTORISATION  * 30
      INTEGER    I_PAS_DE_TPS , I_NB_PARAM , I_TYPE_SORTIE , I_NBRE_STAT
      INTEGER    I_CQ_BDM(120,KNBMESS),I_CODE_RETOUR_EXT , I_NB_MESS
      REAL       Z_DONNEES(120,KNBMESS)

      REAL  DL_MIN_LAT , DL_MAX_LAT
      REAL  DL_MIN_LON , DL_MAX_LON

      CHARACTER  CLINDIC*12,CLSATOUT(10)*3,CLNBSATOUT(10)*6
      INTEGER    IVNM(JP_NBX_PAR),IFLG(JP_NBX_PAR),INBSATOUT(10)
      REAL       ZPOB(JP_NBX_PAR),ZPRL(JP_NBX_PAR),ZVAR(JP_NBX_PAR)

      INTEGER    ISTCLC(30,0:3),ISTLSQ(30,0:3),ISTNUM(30)
      INTEGER    ICODCN(0:63),ICODMI(0:3),INCQ(0:3)
      INTEGER    ITARCH(3)


! ----------------------------------------------------------------------
! code pour realiser des sorties formatees  OBSOUL (SOPRANO)

      character entete * 84, wagon_prov * 34
      character wagon  * 34, fmt_final * 117
! ----------------------------------------------------------------------


#include "oulan_yombitu.h"

! ----------------------------------------------------------------------
! code pour realiser des sorties formatees  OBSOUL (SOPRANO)

      entete = "(I4,1X,I2,1X,I9,1X,F9.5,1X,F10.5,1X,A12,1X,I8,1X,I6,1X"
      entete = trim(adjustl(entete)) // ",ES12.5,1X,I5,1X,I7,1X,I7,1X,"
      wagon_prov = "(I5,'(1X,I3,1X,3(ES12.5,1X),I11)')"                       
! ----------------------------------------------------------------------

      KNBMECR           = 0
      KPLEIN            = 0

      IBLA=1             ! defaut archivage sans eclatement
      ITARCH(1)=1        ! hirs
      ITARCH(2)=1        ! msu
      ITARCH(3)=1        ! ssu

      CL_NULL  = 'NULL'//CHAR(0)

      INCQ(0)           = 0
      INCQ(1)           = 2
      INCQ(2)           = 3
      INCQ(3)           = 1

      IRETOVS           = 0
      IPBSC1            = 0
      IPBSC2            = 0
      IPBLALO           = 0
      IPBCOUV           = 0

      ICODCN            = 0
      ICODCN(32)        = 1
      ICODCN(16)        = 2
      ICODCN( 8)        = 3

      ICODMI            = 0
      ICODMI( 1)        = 1

      IZERO             = 0
      ICQUN             = 1

      DO J1=1,30
        ISTNUM(J1)      = 0
        DO J2=0,3
          ISTCLC(J1,J2) = 0
          ISTLSQ(J1,J2) = 0
        ENDDO
      ENDDO

      INUMST = 0

      DO J=1,10
        CLNBSATOUT(J) = '      '
        CLSATOUT(J)   = '   '
        INBSATOUT(J)  = 0
      ENDDO

      I_NB_SAT_OUT = 0

!-----------------------------------------------------------------------

!  Initialisations des arguments de la fonction d'extraction
!  ---------------------------------------------------------

      CL_TYPE_MESS( 1:10) = CDTYPM
      CL_TYPE_MESS(11:20) = '          '
      CL_VERS_MESS        = '%                   '
      CL_MIN_DATE         = CDATDEB(2)
      CL_MAX_DATE         = CDATFIN(2)
      CL_AUTORISATION     = 'OPER                          '
      CL_LAST_ARRIVED     = 'Y'
      CL_LISTE_STAT(1)    = 'NULL'
      CL_LISTE_PARAM(1)   = 'NULL           '

      I_PAS_DE_TPS        = 0
      I_NB_PARAM          = 0
      I_TYPE_SORTIE       = 3
      I_NBRE_STAT         = 0
      I_NB_MESS           = KNBMESS

      DL_MIN_LAT          = PLATS
      DL_MAX_LAT          = PLATN
      DL_MIN_LON          = PLONO
      DL_MAX_LON          = PLONE

      CL_DONNEES          = ' '
      Z_DONNEES           = RABSI
      I_CQ_BDM            = NABSI

!-----------------------------------------------------------------------

!  Extraction
!  ----------

 100  CONTINUE

      PRINT *,' '
      PRINT *,' Extraction des ',CDTYPM
      PRINT *,' '

      CALL RDLLTDOMAINDECOD( CL_TYPE_MESS , CL_VERS_MESS , CL_MIN_DATE ,
     &                       CL_MAX_DATE , CL_AUTORISATION ,
     &                       CL_LAST_ARRIVED , I_PAS_DE_TPS ,
     &                       CL_NULL , I_NB_PARAM , Z_DONNEES ,
     &                       CL_DONNEES , CL_NULL , I_TYPE_SORTIE ,
     &                       I_NB_MESS , DL_MIN_LAT , DL_MAX_LAT ,
     &                       DL_MIN_LON , DL_MAX_LON , CL_NULL ,
     &                       I_NBRE_STAT , I_CODE_RETOUR_EXT )

      PRINT *,' '
      PRINT *,' '
      PRINT *,' Fin de l''extraction '
      PRINT *,' '

         IF ( I_CODE_RETOUR_EXT.NE.0 .AND.
     &        I_CODE_RETOUR_EXT.NE.1       ) THEN
            PRINT 101,CDTYPM,I_CODE_RETOUR_EXT
 101        FORMAT(/,' Probleme lors de l''extraction des ',A10,
     S             ' I_CODE_RETOUR_EXT = ',I2,/)
            GOTO 300
         ENDIF

      IF ( I_NB_MESS.EQ.KNBMESS ) KPLEIN = I_NB_MESS
      IF ( NINIT.EQ.1 ) RETURN

!-----------------------------------------------------------------------

!  Traitements
!  -----------

 200  CONTINUE

 ! definition du type d'archivage
      IF ( LMOD1C ) THEN  ! defaut = sans eclatement
        IBLA=0
        IF ( LHIRS ) THEN
          IBLA=IBLA+1
          ITARCH(IBLA)=IBLA
        ENDIF
        IF ( LMSU ) THEN
          IBLA=IBLA+1
          ITARCH(IBLA)=IBLA
        ENDIF
        IF ( LSSU ) THEN
          IBLA=IBLA+1
          ITARCH(IBLA)=IBLA
        ENDIF
      ENDIF

      I_NB_NESDIS    = 0
      I_NB_LANNION   = 0
      I_NB_AUTRE     = 0
      I_NB_NESDIS_P  = 0
      I_NB_LANNION_P = 0
      I_NB_AUTRE_P   = 0
      I_NB_SAT_OUT   = 0

      BOUCLE_MESSAGE: DO JO=1,I_NB_MESS
        IF ( LCUTOFF .AND. 
     &       CL_DONNEES(1,JO)(1:14).GT.CDATFIN(4) ) CYCLE BOUCLE_MESSAGE
        IF ( CL_DONNEES(3,JO)(1:2).EQ.'KW' ) THEN
          I_NB_NESDIS  = I_NB_NESDIS + 1
        ELSE IF ( CL_DONNEES(3,JO)(1:2).EQ.'LF' ) THEN
          I_NB_LANNION = I_NB_LANNION + 1
        ELSE
          I_NB_AUTRE   = I_NB_AUTRE + 1
        ENDIF

!  Selection en fonction du producteur

      IF (  ( CL_DONNEES(3,JO)(1:2).EQ.'KW' .AND. .NOT.L_TOVS_NESDIS  ) 
     & .OR. ( CL_DONNEES(3,JO)(1:2).EQ.'LF' .AND. .NOT.L_TOVS_LANNION )
     &   ) CYCLE BOUCLE_MESSAGE

        IRLN    = NABSO
        IOTP    = NABSO
        IOCH    = NABSO
        ZLAT    = RABSO
        ZLON    = RABSO
        IDAT    = NABSO
        IETM    = NABSO
        ZALT    = RABSO
        INLV    = NABSO
        IRFL    = 11111
        ISTD    = 0
        CLINDIC = " '        ' "
        CLLAT   = '            '
        CLLON   = '            '
        ICQLAT  = 1
        ICQLON  = 1
        ICQDAT  = 1
        ICQETM  = 1
        ICQALT  = 1
        ILSAUTE = 0

        DO JA=1,JP_NBX_PAR
          IVNM(JA) = NABSO
          ZPOB(JA) = RABSO
          ZPRL(JA) = RABSO
          ZVAR(JA) = RABSO
          IFLG(JA) = NABSO
        ENDDO

!  Saisie de la locomotive

        IOTP = NSATEM
        ZLAT = Z_DONNEES(13,JO)
        ZLON = Z_DONNEES(14,JO)
        IF ( I_CQ_BDM(13,JO).EQ.2 .OR. I_CQ_BDM(14,JO).EQ.2 ) THEN
          IPBLALO = 1
          ILSAUTE = 1
        ENDIF
        WRITE (CLLAT(2:11),'(F10.5)') ZLAT
        WRITE (CLLON(2:11),'(F10.5)') ZLON
        IOCH     = 0
        INUACOUV = 0
        IMETINV  = 0
        ITERMER  = 3

        IF ( Z_DONNEES(17,JO).NE.RABSI ) THEN
          IMETHOD  = NINT( Z_DONNEES(17,JO) )
          IMETINV  = KBITLU(IMETHOD,7,2)
          INUACOUV = KBITLU(IMETHOD,1,6)
          INCV     = ICODCN(INUACOUV)
          IMTINV   = ICODMI(IMETINV)

!  inuacouv  32     incv  1  clair
!            16           2  partiellement couvert
!             8           3  nuageux
!             0           0  non defini

!  imetinv    2   imtinv  0
!             1           1

        ENDIF

        ISCAN = NINT(Z_DONNEES(18,JO))
        ISCAN = MOD(ISCAN,100)
        IF ( ISCAN.GT.56 .OR. ISCAN.LT.1 ) THEN
          IPBSC1  = IPBSC1 + 1
          ILSAUTE = 1
        ENDIF
        ISCAN = MAX(2,ISCAN)
        ISCAN = MIN(55,ISCAN)
        KSCPOS = 1 + (ISCAN-2)/3
        IF ( KSCPOS.LT.1 .OR. KSCPOS.GT.18 ) THEN
          IPBSC2 = IPBSC2 + 1
          ILSAUTE = 1
        ENDIF
        IF ( INCV.EQ.0 ) THEN
          IPBCOUV = IPBCOUV + 1
          ILSAUTE = 1
        ENDIF
        IF ( ILSAUTE.EQ.1 ) CYCLE BOUCLE_MESSAGE

        IRETOVS = IRETOVS + 1

        IF (Z_DONNEES(22,JO).NE.RABSI) ITERMER = NINT(Z_DONNEES(22,JO))
        CALL OULAN_CAROBS(IOTP,CDTYPM,INCV,IMTINV,ITERMER,ZLAT,IOCH)

        IDAT = NINT( Z_DONNEES( 7,JO) ) * 10000  +
     &         NINT( Z_DONNEES( 8,JO) ) * 100    +
     &         NINT( Z_DONNEES( 9,JO) )
        IETM = NINT( Z_DONNEES(10,JO) ) * 10000  +
     &         NINT( Z_DONNEES(11,JO) ) * 100    +
     &         FLOOR( Z_DONNEES(12,JO) )
        INOSAT = 3
        IF ( Z_DONNEES(1,JO).NE.RABSI ) THEN
          IINDIC = NINT( Z_DONNEES(1,JO) )
          WRITE (CLINDIC(8:10),'(I3.3)') IINDIC
          ILPREND = 0
          DO JSAT=1,MNBSATSEL(N_TOVS120)
            IF ( IINDIC.EQ.MNOSATSEL(N_TOVS120,JSAT) ) ILPREND = 1
          ENDDO
          IF ( ILPREND.EQ.0 ) THEN
            ILYEST = 0
            DO JSAT=1,I_NB_SAT_OUT
              IF ( CLINDIC(8:10).EQ.CLSATOUT(JSAT) ) ILYEST = JSAT
            ENDDO
            IF ( ILYEST.EQ.0 ) THEN
              I_NB_SAT_OUT = I_NB_SAT_OUT + 1
              IF ( I_NB_SAT_OUT.LE.10 ) THEN
                CLSATOUT(I_NB_SAT_OUT)  = CLINDIC(8:10)
                INBSATOUT(I_NB_SAT_OUT) = 1
              ENDIF
            ELSE IF ( ILYEST.LE.10 ) THEN
              INBSATOUT(ILYEST) = INBSATOUT(ILYEST) + 1
            ENDIF
            CYCLE BOUCLE_MESSAGE
          ENDIF
          ILENVE = 0
          DO JNST=1,INUMST
            IF ( IINDIC.EQ.ISTNUM(JNST) ) ILENVE = JNST
          ENDDO
          IF ( ILENVE.GT.0 ) THEN
            INOSAT = ILENVE
          ELSE
            INUMST = INUMST + 1
            ISTNUM(INUMST) = IINDIC
            INOSAT = INUMST
          ENDIF
        ELSE
          CYCLE
        ENDIF

        IF ( I_CQ_BDM(13,JO).NE.NABSI ) ICQLAT = INCQ(I_CQ_BDM(13,JO))
        IF ( I_CQ_BDM(14,JO).NE.NABSI ) ICQLON = INCQ(I_CQ_BDM(14,JO))
        IF ( I_CQ_BDM(7,JO).NE.NABSI .AND. I_CQ_BDM(8,JO).NE.NABSI
     &       .AND. I_CQ_BDM(9,JO).NE.NABSI )
     &     ICQDAT = MAX0( INCQ(I_CQ_BDM(7,JO)) ,
     &                    MAX0( INCQ(I_CQ_BDM(8,JO)) ,
     &                          INCQ(I_CQ_BDM(9,JO)) ) )
        IF ( I_CQ_BDM(10,JO).NE.NABSI .AND. I_CQ_BDM(11,JO).NE.NABSI
     &       .AND. I_CQ_BDM(12,JO).NE.NABSI )
     &     ICQETM = MAX0( INCQ(I_CQ_BDM(10,JO)) ,
     &                    MAX0( INCQ(I_CQ_BDM(11,JO)) ,
     &                          INCQ(I_CQ_BDM(12,JO)) ) )
        IRFL = ICQALT*10000 + ICQETM*1000 + ICQDAT*100 + ICQLON*10 +
     &         ICQLAT

        IF ( Z_DONNEES(5,JO).NE.RABSI )
     &    ISTD = INT(Z_DONNEES(5,JO)+REPSILON)

        ISTCLC(INOSAT,INCV)     = ISTCLC(INOSAT,INCV) + 1
        ISTLSQ(INOSAT,ITERMER)  = ISTLSQ(INOSAT,ITERMER)  + 1

!  information auxiliaire

! info 1  NCMSOE, NCMCHU, NCMDPT, NCMSLC
        IVNM(1) = NVNUMB(59)
        IF ( Z_DONNEES(15,JO).NE.RABSI ) ZPOB(1) = Z_DONNEES(15,JO)  
        IF ( Z_DONNEES(16,JO).NE.RABSI ) ZPRL(1) = Z_DONNEES(16,JO)
        ZVAR(1) = FLOAT( INUACOUV )
        IFLG(1) = NINT(Z_DONNEES(18,JO))
! info 2  NCMOZO, NCMPP1, NCMCLC, NCMLSQ
        IVNM(2) = NVNUMB(59)
        IF ( Z_DONNEES(19,JO).NE.RABSI ) ZPOB(2) = Z_DONNEES(19,JO)
        IF ( Z_DONNEES(20,JO).NE.RABSI ) ZPRL(2) = Z_DONNEES(20,JO)
        IF ( Z_DONNEES(21,JO).NE.RABSI ) ZVAR(2) = Z_DONNEES(21,JO)
        IFLG(2) = ITERMER
! info 3  NCMHLS, NCMSKT, NCMPP2
        IVNM(3) = NVNUMB(59)
        ZPOB(3) = Z_DONNEES(23,JO)
        ZPRL(3) = Z_DONNEES(24,JO)
        ZVAR(3) = Z_DONNEES(25,JO) 

        INBP = 3

!  Saisie des wagons
!  -----------------

!  composition du code qualite (IFLG) :

!     bits 1 et 2   code qualite coordonnee verticale
!     bits 3 et 4   code qualite parametre mesure
!     bit    12     coordonnee verticale en Pascals

!  profil de temperatures virtuelles et contenus en eau precipitable

        IF ( LTVQEP ) THEN

! ATTENTION : ne sont saisies que les couches au dessus de 10hPa

          DO JTV=12,15
            ID = 25 + (JTV-1)*3
            IF ( Z_DONNEES(ID+1,JO).NE.RABSI .AND.
     &           Z_DONNEES(ID+2,JO).NE.RABSI .AND.
     &           Z_DONNEES(ID+3,JO).NE.RABSI .AND.
     &           I_CQ_BDM(ID+3,JO).NE.2            ) THEN
              INBP = INBP + 1
              IVNM(INBP) = NVNUMB(67)
              ZPOB(INBP) = Z_DONNEES(ID+2,JO)
              ZPRL(INBP) = Z_DONNEES(ID+1,JO)
              ZVAR(INBP) = Z_DONNEES(ID+3,JO)
              ICQPA      = 3
              ICQCV      = 3
              IF ( I_CQ_BDM(ID+3,JO).NE.NABSI )
     &          ICQPA = I_CQ_BDM(ID+3,JO)
              IF ( I_CQ_BDM(ID+2,JO).NE.NABSI )
     &          ICQCV = I_CQ_BDM(ID+2,JO)
              IFLG(INBP) = 0
              IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV,1)
              IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA,3)
              IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
            ENDIF
          ENDDO

!  pour diminuer le volume des fichiers d'obs. cette information non
!  utilisee n'est plus saisie

!         DO JQEP=1,3
!           ID = 70 + (JQEP-1)*3
!           IF ( Z_DONNEES(ID+3,JO).NE.RABSI ) THEN
!             INBP = INBP + 1
!             IVNM(INBP) = NVNUMB(6)
!             ZPOB(INBP) = Z_DONNEES(ID+2,JO)
!             ZPRL(INBP) = Z_DONNEES(ID+1,JO)
!             ZVAR(INBP) = Z_DONNEES(ID+3,JO)
!             ICQPA      = 3
!             ICQCV      = 3
!             IF ( I_CQ_BDM(ID+3,JO).NE.NABSI )
!    &          ICQPA = I_CQ_BDM(ID+3,JO)
!             IF ( I_CQ_BDM(ID+2,JO).NE.NABSI )
!    &          ICQCV = I_CQ_BDM(ID+2,JO)
!             IFLG(INBP) = 0
!             IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV,1)
!             IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA,3)
!             IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
!           ENDIF
!         ENDDO
        ENDIF

        INBP0=INBP

!  profil de temperatures de brillances

        DO J1C = 1, IBLA

          INBP=INBP0

          IF ( ITARCH(1).EQ.J1C ) THEN
            DO JTB=1,19
              ID = 79 + JTB
              IF ( Z_DONNEES(ID,JO).NE.RABSI ) THEN
                INBP = INBP + 1
                IVNM(INBP) = NVNUMB(50)
                ZPOB(INBP) = FLOAT(JTB)
                ZPRL(INBP) = RABSO
                ZVAR(INBP) = Z_DONNEES(ID,JO)
                ICQPA      = 3
                IF ( I_CQ_BDM(ID,JO).NE.NABSI )
     &            ICQPA = I_CQ_BDM(ID,JO)
                IFLG(INBP) = 0
                IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV,1)
                IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA,3)
                IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
              ENDIF
            ENDDO
          ENDIF

          IF ( ITARCH(2).EQ.J1C ) THEN
            DO JTB=21,24
              ID = 79 + JTB
              IF ( Z_DONNEES(ID,JO).NE.RABSI ) THEN
                INBP = INBP + 1
                IVNM(INBP) = NVNUMB(50)
                ZPOB(INBP) = FLOAT(JTB)
                ZPRL(INBP) = RABSO
                ZVAR(INBP) = Z_DONNEES(ID,JO)
                IF ( I_CQ_BDM(ID,JO).NE.NABSI )
     &            ICQPA = I_CQ_BDM(ID,JO)
                IFLG(INBP) = 0
                IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV,1)
                IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA,3)
                IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
              ENDIF
            ENDDO
          ENDIF

          IF ( ITARCH(3).EQ.J1C ) THEN
            DO JTB=25,27
              ID = 79 + JTB
              IF ( Z_DONNEES(ID,JO).NE.RABSI ) THEN
                INBP = INBP + 1
                IVNM(INBP) = NVNUMB(50)
                ZPOB(INBP) = FLOAT(JTB)
                ZPRL(INBP) = RABSO
                ZVAR(INBP) = Z_DONNEES(ID,JO)
                IF ( I_CQ_BDM(ID,JO).NE.NABSI )
     &            ICQPA = I_CQ_BDM(ID,JO)
                IFLG(INBP) = 0
                IFLG(INBP) = KBITEC(IFLG(INBP),ICQCV,1)
                IFLG(INBP) = KBITEC(IFLG(INBP),ICQPA,3)
                IFLG(INBP) = KBITEC(IFLG(INBP),ICQUN,12)
              ENDIF
            ENDDO
          ENDIF

          INLV = INBP
          IRLN = NCILET + INLV*NCILBO

!  Copie de l'observation sur le fichier d'obs.

          IF ( INBP.GT.3 ) THEN
            IF ( CL_DONNEES(3,JO)(1:2).EQ.'KW' ) THEN
              I_NB_NESDIS_P  = I_NB_NESDIS_P + 1
            ELSE IF ( CL_DONNEES(3,JO)(1:2).EQ.'LF' ) THEN
              I_NB_LANNION_P = I_NB_LANNION_P + 1
            ELSE
              I_NB_AUTRE_P   = I_NB_AUTRE_P + 1
            ENDIF

           write(wagon,fmt=wagon_prov) INBP
	   fmt_final = trim(adjustl(entete))//trim(adjustl(wagon))//")"

          WRITE (NULOBI,fmt_final) IRLN,IOTP,IOCH,ZLAT,ZLON,CLINDIC,
     &                     IDAT,IETM,ZALT,INLV,IRFL,ISTD,
     &                     (IVNM(J),ZPOB(J),ZPRL(J),ZVAR(J),
     &                     IFLG(J),J=1,INBP)
            KNBMECR = KNBMECR + 1
            KNBWAG  = KNBWAG + INBP
            IF ( L_GEOPOINTS ) 
     &        WRITE (NULGEO,'(F11.5,F11.5,I5)') ZLON,ZLAT,IINDIC
          ENDIF
        ENDDO

      ENDDO BOUCLE_MESSAGE

!-----------------------------------------------------------------------

 300  WRITE (NULOUT,301) I_NB_MESS,IRETOVS,(IRETOVS*100.)/I_NB_MESS,
     &                   IPBLALO,IPBSC1,IPBSC2,IPBCOUV
C
      WRITE (NULOUT,302)
      DO JNST=1,INUMST
        ICLCTOT = ISTCLC(JNST,0) + ISTCLC(JNST,1) +
     &            ISTCLC(JNST,2) + ISTCLC(JNST,3)
        WRITE (NULOUT,303) ISTNUM(JNST),(ISTCLC(JNST,J),J=1,3),
     &                     ISTCLC(JNST,0),ICLCTOT
      ENDDO
      WRITE (NULOUT,304)
      DO JNST=1,INUMST
        ILSQTOT = ISTLSQ(JNST,0) + ISTLSQ(JNST,1) +
     &            ISTLSQ(JNST,2) + ISTLSQ(JNST,3)
        WRITE (NULOUT,303) ISTNUM(JNST),(ISTLSQ(JNST,J),J=0,3),ILSQTOT
      ENDDO
      WRITE (NULOUT,305) I_NB_NESDIS,I_NB_NESDIS_P,I_NB_LANNION,
     &                   I_NB_LANNION_P,I_NB_AUTRE,I_NB_AUTRE_P
      DO J=1,10
        IF ( INBSATOUT(J).GT.0 )
     &    WRITE (CLNBSATOUT(J),'(I6)') INBSATOUT(J)
      ENDDO
      IF ( I_NB_SAT_OUT.GT.0 ) WRITE (NULOUT,306) CLSATOUT,CLNBSATOUT

 301  FORMAT(/,' Nombre total de TOVS extraits   : ',I6,/,
     & ' Nombre de TOVS retenus',10X,': ',I6,'   ( ',F6.2,' % )',//,
     & ' probleme sur lat./lon.          : ',I6,/,
     & ' probleme sur compteur pos. no 1 : ',I6,/,
     & ' probleme sur compteur pos. no 2 : ',I6,/,
     & ' probleme sur couv. nuageuse     : ',I6,/)
 302  FORMAT(/,' methode d''inversion   couvert       clair   part. c',
     &       'ouvert    pas d''info.      total',/,85('-'))
 303  FORMAT(' satellite ',I3,5X,4(I9,4X),I13)
 304  FORMAT(/,' masque terre/mer       terre',9X,'mer',10X,'cote',7X,
     &       'pas d''info.      total',/,85('-'))
 305  FORMAT(/,
     & '   producteur      nombre de messages extraits     nom',
     & 'bre de messsages retenus',//,5X,'NESDIS',20X,I5,27X,I5,/,5X,
     & 'Lannion',19X,I5,27X,I5,/,5X,'autre',21X,I5,27X,I5,/)
 306  FORMAT(/,' Satellites extraits, non retenus : ',10(3X,A3,2X),/,
     &       36X,10(A6,2X))

!-----------------------------------------------------------------------

      RETURN
      END
